Bug 587489

Summary: Add new build target for Eclipse
Product: [Community] Publican Reporter: Isaac Rooskov <irooskov>
Component: publicanAssignee: Jeff Fearn <jfearn>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: urgent Docs Contact:
Priority: low    
Version: 1.6CC: bclare, jfearn, mmcallis, nb, publican-list, r.landmann, yshao
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
See Also: https://bugzilla.redhat.com/show_bug.cgi?id=588613
Whiteboard:
Fixed In Version: publican-1.6.3-0.fc12 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2010-05-17 14:57:25 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Isaac Rooskov 2010-04-29 22:39:19 EDT
Description of problem:
Currently in the JBoss Developer Studio project, whenever we want to convert documentation into "Eclipse Help" formatted content we specify an "eclipse" format plugin in the Maven build phase. Since it is our desire (from a content services standpoint) to build everything with Publican it would be advantagous to our cause to have this ability in Publican as well.

Version-Release number of selected component (if applicable):
N/A

How reproducible:
N/A

Steps to Reproduce:
1.
2.
3.
N/A
  
Actual results:
Doesn't have a build target that generates a plug-in for Eclipse to be intergrated into the Eclipse help system.

Expected results:
Would have a build target that generates a plug-in for Eclipse to be intergrated into the Eclipse help system.

Additional info:
contact Isaac Rooskov: irooskov@redhat.com
or
contact Ben Clare: bclare@redhat.com
Comment 1 Jeff Fearn 2010-05-04 00:43:45 EDT
FYI the Fedora docbook-style-xsl package does not ship the eclipse XSL, so you will need to open a bug to get that changed before this can be addressed. 

Something like this is required:

$ cvs diff -u docbook-style-xsl.Makefile
Index: docbook-style-xsl.Makefile
===================================================================
RCS file: /cvs/pkgs/rpms/docbook-style-xsl/devel/docbook-style-xsl.Makefile,v
retrieving revision 1.8
diff -u -r1.8 docbook-style-xsl.Makefile
--- docbook-style-xsl.Makefile  23 Feb 2009 10:40:22 -0000      1.8
+++ docbook-style-xsl.Makefile  4 May 2010 04:42:46 -0000
@@ -6,11 +6,12 @@
 install: install-xsl install-img install-extensions install-misc install-epub
 
 install-xsl:
-       mkdir -p $(DESTDIR)/{common,fo,html,htmlhelp/doc,javahelp,lib,template,xhtml,xhtml-1_1,manpages,profiling,highlighting,roundtrip,website}
+       mkdir -p $(DESTDIR)/{common,eclipse,fo,html,htmlhelp/doc,javahelp,lib,template,xhtml,xhtml-1_1,manpages,profiling,highlighting,roundtrip,website}
        cp common/*.dtd $(DESTDIR)/common
        cp common/*.ent $(DESTDIR)/common
        cp common/*.xml $(DESTDIR)/common
        cp common/*.xsl $(DESTDIR)/common
+       cp eclipse/*.xsl $(DESTDIR)/eclipse
        cp fo/*.xml $(DESTDIR)/fo
        cp fo/*.xsl $(DESTDIR)/fo
        cp html/*.xml $(DESTDIR)/html
Comment 2 Isaac Rooskov 2010-05-04 01:35:43 EDT
Thanks Jeff, I have opened a bug for docbook-style-xsl as you have suggested, with the fix you suggest. That bug is linked to this one.
Comment 3 Jeff Fearn 2010-05-04 02:57:51 EDT
Added eclipse xsl and handling code. Added 3 new config parameters:


ec_id:
     Eclipse plugin ID. Defaults to "$product.$docname"

ec_name:
     Eclipse plugin name. Defaults to "$product $docname"

ec_provider:
     Eclipse plugin provider. Defaults to "Publican-Publican::VERSION"



Example plugin.xml:

$ cat build/en-US/eclipse/plugin.xml 
<?xml version="1.0" encoding="utf-8" standalone="no"?>
<plugin name="Publican Users_Guide" id="Publican.Users_Guide" version="1.0" provider-name="Publican-1.6.2">
  <extension point="org.eclipse.help.toc">
    <toc file="toc.xml" primary="true"/>
  </extension>
  <extension point="org.eclipse.help.index">
    <index file="index.xml"/>
  </extension>
</plugin>

You won't be able to test this unless you rebuild your docbook-style-xsl package.
Comment 4 Ruediger Landmann 2010-05-06 01:57:30 EDT
confirmed that with docbook-style-xsl-1.75.2, publican 1.6.3.t150 builds a set of files for the eclipse target.
Comment 5 BenC 2010-05-07 03:14:52 EDT
The plugin loads in Eclipse successfully. Branded styles are not present though.

I note that the JDocBook eclipse plugin includes the JBoss community styles:

<format>
  <formatName>eclipse</formatName>
  <stylesheetResource>classpath:/xslt/org/jboss/eclipse.xsl</stylesheetResource>
  <finalName>index.html</finalName>
</format>

The majority of Eclipse Help (including Hibernate Developer Guide) have little or no styling.

Can we include the styles as it will add to the presentation or is styling not recommended in Eclipse Help to minimise the package size?
Comment 6 Jeff Fearn 2010-05-09 23:43:28 EDT
(In reply to comment #5)
> The plugin loads in Eclipse successfully. Branded styles are not present
> though.
> 
> I note that the JDocBook eclipse plugin includes the JBoss community styles:
> 
> <format>
>   <formatName>eclipse</formatName>
>  
> <stylesheetResource>classpath:/xslt/org/jboss/eclipse.xsl</stylesheetResource>
>   <finalName>index.html</finalName>
> </format>
> 
> The majority of Eclipse Help (including Hibernate Developer Guide) have little
> or no styling.
> 
> Can we include the styles as it will add to the presentation or is styling not
> recommended in Eclipse Help to minimise the package size?    

It was an oversight, fixes XSL to pull in branding elements.
Comment 7 Ruediger Landmann 2010-05-11 00:45:01 EDT
verified that brands are applied to HTML files in version 1.6.2.t169
Comment 8 Fedora Update System 2010-05-13 18:21:12 EDT
publican-1.6.3-0.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/publican-1.6.3-0.fc13
Comment 9 Fedora Update System 2010-05-13 18:22:26 EDT
publican-1.6.3-0.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/publican-1.6.3-0.fc12
Comment 10 Isaac Rooskov 2010-05-13 18:41:33 EDT
Thanks for all the hard work in making this happen :D
Comment 11 Fedora Update System 2010-05-15 16:36:53 EDT
publican-1.6.3-0.fc12 has been pushed to the Fedora 12 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update publican'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/publican-1.6.3-0.fc12
Comment 12 Fedora Update System 2010-05-15 16:46:03 EDT
publican-1.6.3-0.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update publican'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/publican-1.6.3-0.fc13
Comment 13 Fedora Update System 2010-05-17 14:56:08 EDT
publican-1.6.3-0.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2010-05-17 14:59:59 EDT
publican-1.6.3-0.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.